<%-- $Id:edit_filetype.jsp 3820 2007-10-12 10:03:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.DATAFILETYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	DataFileType fileType = null;
	boolean readCurrentFileType = true;
	int currentFileTypeId = 0;

	if (itemId == 0)
	{
		title = "Create data file type";
		cc.removeObject("item");
		currentFileTypeId = Values.getInt(cc.getPropertyValue("genericType"), 0);
		if (currentFileTypeId == 0)
		{
			currentFileTypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0), 0);
		}
	}
	else
	{
		fileType = DataFileType.getById(dc, itemId);
		fileType.checkPermission(Permission.WRITE);
		cc.setObject("item", fileType);
		title = "Edit data file type -- " + HTML.encodeTags(fileType.getName());
		try
		{
			ItemSubtype ft = fileType.getGenericType();
			if (ft != null) currentFileTypeId = ft.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFileType = false;
		}
	}
	// Query to retrieve file types
	final ItemQuery<ItemSubtype> fileTypeQuery = ItemSubtype.getQuery(Item.FILE);
	fileTypeQuery.order(Orders.asc(Hql.property("name")));
	fileTypeQuery.setCacheResult(true);

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	final String unchangeableClazz = "class=\"text required unchangeable\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), fileType);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Data file type" tab
		function validateDataFileType()
		{
			var frm = document.forms['fileType'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (frm.externalId && Main.trimString(frm.externalId.value) == '')
			{
				alert("You must enter an external ID");
				frm.externalId.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['fileType'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (fileType == null)
			{
				%>
				var frm = document.forms['fileType'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="fileType" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*340)+"px;"%>" 
			position="bottom"  remember="<%=fileType != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Data file type" validate="validateDataFileType()" helpid="datafiletype.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(fileType == null ? Values.getString(cc.getPropertyValue("name"), "New data file type") : fileType.getName())%>" 
					size="40" maxlength="<%=DataFileType.MAX_NAME_LENGTH%>"></td>
			</tr>
			<%
			if (fileType == null)
			{
				// For new file types only
				Set<Item> items = Metadata.getFileStoreEnabledItems();
				int itemCode = Values.getInt(cc.getPropertyValue("itemType"), -1);
				%>
				<tr>
					<td class="prompt">External ID</td>
					<td><input <%=unchangeableClazz%> type="text" name="externalId" 
						value="<%=HTML.encodeTags(cc.getPropertyValue("externalId"))%>" 
						size="40" maxlength="<%=DataFileType.MAX_EXTERNAL_ID_LENGTH%>"></td>
				</tr>
				<tr>
					<td class="prompt">Item type</td>
					<td>
						<select name="itemType" class="required unchangeable">
						<%
						for (Item item : items)
						{
							String selected = itemCode == item.getValue() ? "selected" : "";
							%>
							<option value="<%=item.name()%>" <%=selected%>><%=item.toString() %>
							<%
						}
						%>
						</select>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<td class="prompt">File extension</td>
				<td><input <%=clazz%> type="text" name="extension" 
					value="<%=HTML.encodeTags(fileType == null ? Values.getString(cc.getPropertyValue("extension")) : fileType.getExtension())%>" 
					size="40" maxlength="<%=DataFileType.MAX_EXTENSION_LENGTH%>"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Generic file type</td>
				<td colspan="2">
					<select name="generictype_id" <%=!readCurrentFileType ? "disabled readonly class=\"disabled\"" : ""%>>
					<%
					if (!readCurrentFileType)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						ItemResultList<ItemSubtype> fileTypes = fileTypeQuery.list(dc);
						for (ItemSubtype ft : fileTypes)
						{
							int id = ft.getId();
							%>
							<option 
								value="<%=fileType != null && id == currentFileTypeId ? -id : id%>" 
								<%=id == currentFileTypeId ? "selected" : ""%>
								><%=HTML.encodeTags(ft.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(fileType == null ? cc.getPropertyValue("description") : fileType.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'fileType', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>
				&nbsp;<i><base:icon image="required.gif" /> = required information</i>
				<%if (fileType == null) {%><br>
				<i><base:icon image="unchangeable.gif" /> = can't be changed later</i>
				<%}%>
			</div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
