<%-- $Id: view_bioplate.jsp 5722 2011-09-07 09:26:07Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Martin
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOPLATE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	BioPlate bioplate = BioPlate.getById(dc, itemId);
	Item bioMaterialType = bioplate.getBioPlateType().getBioMaterialType();
	PlateGeometry geometry = bioplate.getPlateGeometry();
	
	final boolean writePermission = bioplate.hasPermission(Permission.WRITE);
	final boolean deletePermission = bioplate.hasPermission(Permission.DELETE);
	final boolean sharePermission = bioplate.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = bioplate.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = bioplate.isRemoved();
	final boolean isUsed = isRemoved && bioplate.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = bioplate.isOwner();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, bioplate);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="tabcontrol.js,table.js,ajax.js,json2.js" 
		styles="toolbar.css,table.css,headertabcontrol.css,path.css,plate.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'SharePlate', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function viewWells()
		{
			location.href = 'wells/index.jsp?ID=<%=ID%>&bioplate_id=<%=itemId%>';
		}
		function viewEvents()
		{
			location.href = 'events/index.jsp?ID=<%=ID%>&bioplate_id=<%=itemId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'history' && tabId != '<%=tab%>')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=itemId%>&tab='+tabId;
			}
			else if (tabId == 'wells')
			{
				viewWells();
			}
			else if (tabId == 'events')
			{
				viewEvents();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function editWell(wellId)
		{
			Main.viewOrEditItem('<%=ID%>', 'BIOWELL', wellId, true);
		}
		function showWellInfo(evt, coordinate, wellId)
		{
			// Display the 'wellInfo' postit note
			var wellInfo = document.getElementById('wellInfo');
			var wellTd = document.getElementById('well.' + wellId);
			var pos = Main.getElementPosition(wellTd);
			wellInfo.style.left = (pos.left + pos.width - 5) + 'px';
			wellInfo.style.top = (pos.top + 10) + 'px';
			Main.show('wellInfo');

			// Get the well information
			var info = wellInfoCache['well.'+wellId];
			if (!info)
			{
				// Use Ajax to load the information
				wellInfo.innerHTML = '[' + coordinate + '] loading, please wait...';
				info = loadWellInfo(wellId);
			}
			var html;
			var bioMaterial = info.bioMaterial;
			if (bioMaterial)
			{
				if (bioMaterial.denied)
				{
					html = 'Denied';
				}
				else
				{
					var id = bioMaterial.id;
					var type = bioMaterial.type;
					var subtype = bioMaterial.subtype;
					html = Main.linkItem('<%=ID%>', type, id, bioMaterial.editable, bioMaterial.name);
					html += ': <b>' + type + '</b>';
					if (subtype) html += ' <span class="itemsubtype">[' + subtype.name + ']</span>';
					html += '<br>'+bioMaterial.description;
				}
			}
			else
			{
				html = 'Empty';
			}
			wellInfo.innerHTML = html;
		}
		function hideWellInfo()
		{
			Main.hide('wellInfo');
		}
		var wellInfoCache = new Array();
		function loadWellInfo(wellId)
		{
			var request = Ajax.getXmlHttpRequest();
			var url = 'wells/ajax.jsp?ID=<%=ID%>&cmd=WellInfo&encodeStrings=1&item_id=' + wellId;
			request.open("GET", url, false); 
			// NOTE! 'false' causes code to wait for the response. aka. 'Synchronous AJAX' or SJAX.
			request.send(null);
			var response = Ajax.parseJsonResponse(request.responseText);
			if (response.status != 'ok')
			{
				alert(response.message);
				return false;
			}

			wellInfoCache['well.'+wellId] = response;
			return response;
		}
		function viewOrEditWellItem(event, itemType, itemId, editable)
		{
			//Main.viewOrEditItem('<%=ID%>', itemType, itemId, editable);
			Main.itemOnClick(event, '<%=ID%>', itemType, itemId, editable);
		}
		function moveBioMaterial()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&item_id=<%=itemId%>&cmd=MoveBioMaterial', 'MoveBioMaterial', 900, 600);
		}
		function createChildBioPlate()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&item_id=<%=itemId%>&cmd=CreateChildBioPlate', 'CreateChildBioPlate', 900, 600);
		}
		</script>
	</base:head>
	<base:body attributes="onmouseout='hideWellInfo()'">
		<p>
		<p:path>
			<p:pathelement title="Bioplates" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(bioplate.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="<%=tab%>" switch="switchTab" remember="false">
		<t:tab id="properties" title="Properties">
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this bioplate" : "You do not have permission to edit this bioplate"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!bioplate.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this bioplate" : "You do not have permission to delete this bioplate"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=bioplate.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this bioplate" : "You do not have permission to restore this bioplate"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this bioplate to other user, groups and projects" : "You do not have permission to share this bioplate"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button 
				image="move_to_plate.png" 
				onclick="moveBioMaterial()" 
				title="Move biomaterial&hellip;" 
				tooltip="Move biomaterial on this plate to another plate" 
			/>
			<tbl:button 
				image="add.png" 
				onclick="createChildBioPlate()" 
				title="<%="Create child bioplate" + (bioMaterialType == Item.EXTRACT ? "/bioassay" : "") +"&hellip;"%>" 
				tooltip="Create one or more child biomaterial plates" 
				visible="<%=bioMaterialType != null%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'plate.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(bioplate)%></i></div>
			<%
			if (bioplate.isRemoved() || bioplate.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=bioplate.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(bioplate.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Barcode</td>
				<td><%=HTML.encodeTags(bioplate.getBarcode())%></td>
			</tr>
			<tr>
				<td class="prompt">Destroyed</td>
				<td><%=bioplate.isDestroyed() ? "yes" : "no"%></td>
			</tr>
			<tr>
				<td class="prompt">Bioplate type</td>
				<td><base:propertyvalue item="<%=bioplate%>" property="bioPlateType" /></td>
			</tr>
			<tr>
				<td class="prompt">Geometry</td>
				<td><base:propertyvalue item="<%=bioplate%>" property="plateGeometry" /></td>
			</tr>
			<tr>
				<td class="prompt">Free (total) wells</td>
				<td><%=bioplate.getFreeWells()%> (<%=bioplate.getTotalWells()%>)</td>
			</tr>
			<tr>
				<td class="prompt">Freezer</td>
				<td><base:propertyvalue item="<%=bioplate%>" property="freezer" /></td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=bioplate%>" property="owner" /></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(bioplate.getDescription())%></td>
			</tr>
			</table>
			
			<base:section id="wells" title="Wells" context="<%=cc%>">
				<table class="plate" cellspacing="0" cellpadding="0" onmouseout="event.cancelBubble=true">
				<%
				int columns = geometry.getColumns();
				int rows = geometry.getRows();
				WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
				WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
				%>
				<tr><td></td>
				<%
				for (int c = 0; c < columns; ++c)
				{
					%>
					<td class="columnheader"><%=colF.format(c)%></td>
					<%
				}
				%>
				</tr>
				<%
				for (int r = 0; r < rows; ++r)
				{
					String row = rowF.format(r);
					%>
					<tr><td class="rowheader"><%=row%></td>
					<%
					for (int c = 0; c < columns; ++c)
					{
						BioWell well = bioplate.getBioWell(r, c);
						boolean isEmpty = well.isEmpty();
						boolean hasBeenUsed = well.hasBeenUsed();
						boolean canAddBioMaterial = well.canAddBioMaterial();
						boolean canClearBioMaterial = well.canClearBioMaterial();
						boolean usePermission = well.hasPermission(Permission.USE);
						
						boolean deniedBioMaterial = false;
						
						String cls = "well";
						String tooltip = "";
						String onClick = null;
						String onMouseOver = "hideWellInfo()";
						
						if (isEmpty)
						{
							cls += " empty";
							if (usePermission && canAddBioMaterial)
							{
								// The used is allowed to add biomaterial to the empty well
								cls += " editable";
								onClick = "editWell(" + well.getId() + ")";
								tooltip = "Add biomaterial to this well";
							}
							else if (hasBeenUsed) 
							{
								// The well has been used and it is not allowed to add biomaterial
								cls += " used";
								onMouseOver = "showWellInfo(event, '" + row + (c+1) + "', " + well.getId() + ")";
								tooltip = "This well has already been used";
							}
							else
							{
								// The user doesn't have permission to add biomaterial
								cls += " locked";
								tooltip = "You are not allowed to add biomaterial to this well";
							}
						}
						else
						{
							cls += " filled";
							try
							{
								MeasuredBioMaterial bioMaterial = well.getBioMaterial();
								onMouseOver = "showWellInfo(event, '" + row + (c+1) + "', " + well.getId() + ")";
								if (usePermission && canClearBioMaterial && bioMaterial.hasPermission(Permission.WRITE))
								{
									// The user is allowed to replace/remove the biomaterial in the well
									cls += " editable";
									onClick = "editWell(" + well.getId() + ")";
									if (canAddBioMaterial)
									{
										// Replace and/or remove
										tooltip = "Change biomaterial in this well";
									}
									else
									{
										// Remove only
										tooltip = "Remove the biomaterial from this well";
									}
								}
								else
								{
									cls += " locked";
									tooltip = "This well is locked for modifications";
								}
							}
							catch (PermissionDeniedException ex)
							{
								cls += " denied";
								tooltip = "Access denied";
							}
						}
						%>
						<td class="<%=cls%>" id="well.<%=well.getId()%>"
							<%=onClick != null ? "onclick=\"" + onClick + "\"" : ""%>
							<%=onMouseOver != null ? "onmouseover=\"" + onMouseOver + "\"" : ""%>
							title="<%=tooltip%>"></td>
						<%
					}
					%>
					</tr>
					<%
				}
				%>
				</table>
				<div class="postit" id="wellInfo" style="display:none; width: 300px; min-height: 30px;" onmouseout="event.cancelBubble=true"></div>
			</base:section>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this bioplate" />
			</jsp:include>
			<%
			// Tables with users/groups/projects that this item is shared to
			MultiPermissions mp = new MultiPermissions(Collections.singleton(bioplate));
			ItemResultList<User> users = mp.getUsers().list(dc);
			ItemResultList<Group> groups = mp.getGroups().list(dc);
			ItemResultList<Project> projects = mp.getProjects().list(dc);
			int totalShare = users.size() + groups.size() + projects.size();
			
			if (totalShare > 0)
			{
				%>
				<base:section 
					id="sharedTo" 
					title="<%="Shared to (" + totalShare + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table 
						id="itemsSharedTo"
						clazz="itemlist"
						columns="all"
					>
						<tbl:columndef 
							id="itemType"
							title="Item type"
						/>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="permissions"
							title="Permissions"
						/>
						<tbl:data>
							<tbl:columns>
							</tbl:columns>
							<tbl:rows>
							<%
							for (Project project : projects)
							{
								Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
								%>			
								<tbl:row>
									<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=project.isRemoved()%>"
									/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							for (Group group : groups)
							{
								Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=group.isRemoved()%>"
									/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%	
							}
							for (User user : users)
							{
								Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=user.isRemoved()%>"
									/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This bioplate is not shared 
				(or, you don't have permission to view the ones it is shared to).
				<%
			}
			%>


		</div>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations" >
				<div class="boxed">
				<jsp:include page="../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
				</div>
			</t:tab>
			<t:tab id="wells" title="Wells" />
			<t:tab id="events" title="Plate events" />
			<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
				<%
				if ("history".equals(tab))
				{
					%>
					<jsp:include page="../../common/history/frameset.jsp">
						<jsp:param name="source_type" value="<%=itemType.name()%>" />
						<jsp:param name="source_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>
			</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
