<%-- $Id: edit_anytoany.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnyToAny"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemNotFoundException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private String getName(BasicItem item, boolean readItem, boolean missingItem, Item itemType, int id)
{
	String name = "";
	if (item instanceof File)
	{
		File toFile = (File)item;
		name = HTML.encodeTags(toFile.getPath().toString());
	}
	else if (item instanceof Nameable)
	{
		Nameable nameable = (Nameable)item;
		name = HTML.encodeTags(nameable.getName());
	}
	else if (!readItem)
	{
		name = "<i>- denied -</i>";
	}
	else if (missingItem)
	{
		name = "<i>- missing -</i> (" + itemType.toString() + "; id=" + id + ")";
	}
	else if (item == null)
	{
		name = "<i>- none -</i>";
	}
	else
	{
		name = HTML.encodeTags(item.toString());
	}
	if (item != null)
	{
		name += " [" + item.getType() + "]";
	}
	return name;
}

%>
<%
final Item itemType = Item.ANYTOANY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	AnyToAny anyToAny = null;

	String fromName = "";
	String toName = "";
	
	if (itemId == 0)
	{
		throw new PermissionDeniedException(Permission.CREATE, "Any-to-any link");
	}
	else
	{
		anyToAny = AnyToAny.getById(dc, itemId);
		cc.setObject("item", anyToAny);
		title = "Edit any-to-any link -- " + HTML.encodeTags(anyToAny.getName());
		
		BasicItem to = null;
		boolean readTo = true;
		boolean missingTo = false;
		
		BasicItem from = null;
		boolean readFrom = true;
		boolean missingFrom = false;
		
		try
		{
			to = anyToAny.getTo();
		}
		catch (PermissionDeniedException ex)
		{
			readTo = false;
		}
		catch (ItemNotFoundException ex)
		{
			missingTo = true;
		}
		
		try
		{
			from = anyToAny.getFrom();
		}
		catch (PermissionDeniedException ex)
		{
			readFrom = false;
		}
		catch (ItemNotFoundException ex)
		{
			missingFrom = true;
		}
	
		toName = getName(to, readTo, missingTo, anyToAny.getToType(), anyToAny.getToId());
		fromName = getName(from, readFrom, missingFrom, anyToAny.getFromType(), anyToAny.getFromId());
	}
	if (anyToAny != null) anyToAny.checkPermission(Permission.WRITE);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "AnyToAny" tab
		function validateAnyToAny()
		{
			var frm = document.forms['anytoany'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['anytoany'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		</script>
	</base:head>
	<base:body>
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="anytoany" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*160)+"px;"%>" 
			position="bottom" remember="<%=anyToAny != null%>">
		<t:tab id="info" title="Any-to-any link" validate="validateAnyToAny()">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">From</td>
				<td><%=fromName%></td>
			</tr>
			<tr>
				<td class="prompt">To</td>
				<td><%=toName%></td>
			</tr>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(anyToAny == null ? Values.getString(cc.getPropertyValue("name"), "New any-to-any link") : anyToAny.getName())%>" 
					size="40" maxlength="<%=AnyToAny.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(anyToAny == null ? cc.getPropertyValue("description") : anyToAny.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'label', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
