<%-- $Id: list_features.jsp 5590 2011-03-16 11:48:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.data.FeatureData"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.ArrayDesignBlock"
	import="net.sf.basedb.core.Feature"
	import="net.sf.basedb.core.FeatureIdentificationMethod"
	import="net.sf.basedb.core.ReporterType"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.Well"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.DataQuery"
	import="net.sf.basedb.core.DataResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.query.Aggregations"	
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Selects"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.FEATURE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final int arrayDesignId = Values.getInt(request.getParameter("arraydesign_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("feature", "features");
final DbControl dc = sc.newDbControl();
DataResultIterator<FeatureData> features = null;
try
{
	final ArrayDesign design = ArrayDesign.getById(dc, arrayDesignId);
	final FeatureIdentificationMethod fiMethod = design.getFeatureIdentificationMethod();
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	
	final DataQuery<FeatureData> query = design.getFeatures();

	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	final ItemQuery<ReporterType> typeQuery = ReporterType.getQuery();
	typeQuery.order(Orders.asc(Hql.property("name")));
	typeQuery.setCacheResult(true);
	
	List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
	
	Enumeration<String, String> plateRows = new Enumeration<String, String>();
	final ItemQuery<PlateGeometry> geometryQuery = PlateGeometry.getQuery();
	geometryQuery.order(Orders.desc(Hql.property("rows")));
	ItemResultIterator<PlateGeometry> result = geometryQuery.iterate(dc);
	int maxRows = result.next().getRows();
	for (int row = 0; row < maxRows; row++)
	{
		plateRows.add(Integer.toString(row), rowFormatter.format(row));
	}
	
	try
	{
		query.join(Hql.leftJoin(null, "reporter", "rpt", null, true));
		cc.configureQuery(dc, query, true);
		if (!"row".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("row")));
		if (!"column".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("column")));
		features = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'features';
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false, '&arraydesign_id=<%=arrayDesignId%>');
		}
		function itemOnClick(evt, itemId)
		{
			viewItem(itemId);
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 540, 460);
		}
		function returnSelected()
		{
			Table.returnSelected(formId, <%=callback != null ? "window.opener."+callback : "null" %>);
			window.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'properties' || tabId == 'annotations' || tabId == 'overview' || tabId == 'history')
			{
				location.href = '../index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=arrayDesignId%>&tab='+tabId;
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function newReporterList()
		{
			Table.submitToPopup(formId, 'CreateReporterList', 540, 400);
		}
		</script>
	</base:head>
	
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Array designs" href="<%="../index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(design.getName())%>" />
		</p:path>

		<t:tabcontrol id="main" active="images" switch="switchTab">
		<t:tab id="properties" title="Properties" />
		<t:tab id="annotations" title="Annotations" />
		
		<t:tab id="images" title="Features">
		
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="features" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="arraydesign_id" 
				value="<%=String.valueOf(arrayDesignId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="position"
				clazz="uniquecol"
				property="position"
				datatype="int"
				title="Position"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="<%=fiMethod == FeatureIdentificationMethod.FEATURE_ID ? "auto" : "always"%>"
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="externalId"
				clazz="uniquecol"
				property="externalId"
				datatype="string"
				title="Feature ID"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="<%=fiMethod == FeatureIdentificationMethod.FEATURE_ID ? "always" : "auto"%>"
			/>
			<tbl:columndef 
				id="block"
				property="arrayDesignBlock.blockNumber"
				datatype="int"
				title="Block"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="metaGridX"
				property="arrayDesignBlock.metaGridX"
				datatype="int"
				title="Meta grid X"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="metaGridY"
				property="arrayDesignBlock.metaGridY"
				datatype="int"
				title="Meta grid Y"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="row"
				property="row"
				datatype="int"
				title="Row"
				sortable="true" 
				filterable="true"
				exportable="true"				
			/>
			<tbl:columndef 
				id="column"
				property="column"
				datatype="int"
				title="Column"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="blockSizeX"
				property="arrayDesignBlock.blockSizeX"
				datatype="int"
				title="Block size X"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="blockSizeY"
				property="arrayDesignBlock.blockSizeY"
				datatype="int"
				title="Block size Y"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="originX"
				property="arrayDesignBlock.originX"
				datatype="int"
				title="Origin X"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="originY"
				property="arrayDesignBlock.originY"
				datatype="int"
				title="Origin Y"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="spacingX"
				property="arrayDesignBlock.spacingX"
				datatype="int"
				title="Spacing X"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="spacingY"
				property="arrayDesignBlock.spacingY"
				datatype="int"
				title="Spacing Y"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="diameter"
				property="arrayDesignBlock.featureDiameter"
				datatype="int"
				title="Diameter"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="reporterList"
				property="$rpt.£reporterListScores"
				datatype="int"
				title="[Rep] Reporter list"
				filterable="true"
				enumeration="<%=Base.getReporterListsEnum(dc)%>"
				multiple="false"
			/>
			<tbl:columndef 
				id="reporter.name"
				property="reporter.name"
				datatype="string"
				title="[Rep] Name"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.externalId"
				clazz="uniquecol"
				property="reporter.externalId"
				datatype="string"
				title="[Rep] ID"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.symbol"
				property="reporter.symbol"
				datatype="string"
				title="[Rep] Gene symbol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.description"
				property="reporter.description"
				datatype="string"
				title="[Rep] Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="reporter.entryDate"
				property="reporter.entryDate"
				datatype="date"
				title="[Rep] Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="reporter.lastUpdate"
				property="reporter.lastUpdate"
				datatype="timestamp"
				title="[Rep] Last update" 
				sortable="true" 
				filterable="true" 
				exportable="true"
				formatter="<%=dateTimeFormatter%>"
			/>
			<%
			Enumeration<String, String> types = new Enumeration<String, String>();
			ItemResultList<ReporterType> reporterTypes = typeQuery.list(dc);
			types.add("", "- none -");
			for (ReporterType rt : reporterTypes)
			{
				types.add(Integer.toString(rt.getId()), HTML.encodeTags(rt.getName()));
			}
			%>
			<tbl:columndef 
				id="reporter.reporterType"
				property="reporter.reporterType"
				sortproperty="reporter.reporterType.name"
				exportproperty="reporter.reporterType.name"
				datatype="int"
				enumeration="<%=types%>"
				title="[Rep] Type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<%
			if (reporterProperties != null)
			{
				for (ExtendedProperty ep : reporterProperties)
				{
					String name = ep.getName();
					%>
					<tbl:columndef
						id="<%="reporter."+name%>"
						property="<%="reporter."+name%>"
						datatype="<%=ep.getType().getStringValue()%>"
						title="<%="[Rep] "+HTML.encodeTags(ep.getTitle())%>"
						sortable="true"
						filterable="true"
						exportable="true"
						formatter="<%=FormatterFactory.getExtendedPropertyFormatter(sc, ep)%>"
					/>
					<%
				}
			}
			%>
			<tbl:columndef 
				id="well.row"
				property="well.row"
				datatype="int"
				title="[Well] Row" 
				sortable="true" 
				filterable="true" 
				enumeration="<%=plateRows%>"
				exportable="true"
				formatter="<%=rowFormatter%>"
			/>
			<tbl:columndef 
				id="well.column"
				property="well.column"
				datatype="int"
				title="[Well] Column" 
				sortable="true" 
				filterable="true" 
				exportable="true"
				formatter="<%=columnFormatter%>"
			/>
			<tbl:columndef 
				id="well.plate"
				property="well.plate.name"
				datatype="string"
				title="[Well] Plate" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:toolbar
				visible="<%=mode.hasToolbar()%>"
				>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button
					image="add.png"
					onclick="newReporterList()"
					title="New reporter list&hellip;"
					tooltip="Create a new reporter list from matching features"
					visible="<%=sc.hasPermission(Permission.CREATE, Item.REPORTERLIST)%>"
				/>
				<tbl:button 
					image="import.gif" 
					onclick="runPlugin('ImportItems')" 
					title="Import&hellip;" 
					tooltip="Import data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
				/>
				<tbl:button 
					image="export.gif" 
					onclick="runPlugin('ExportItems')" 
					title="Export&hellip;" 
					tooltip="Export data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
				/>
				<tbl:button 
					image="runplugin.gif" 
					onclick="runPlugin('RunListPlugin')" 
					title="Run plugin&hellip;" 
					tooltip="Run a plugin" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
				/>
				<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
					wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			</tbl:toolbar>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=features == null ? 0 : features.getTotalCount()%>" 
				visible="<%=mode.hasNavigator()%>"
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="3"
					onchange="presetOnChange()"
				/>
				</tbl:columns>
					
				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasCheck()%>"
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId])" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasRadio()%>"
						/>
					<tbl:header 
						clazz="icons" 
						visible="<%=mode.hasIcons()%>"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>
		
					<tbl:rows>
					<%
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = Values.getInt(request.getParameter("item_id"));
					if (features != null)
					{
						String tooltip = mode.isSelectionMode() ? 
							"Select this item" : "View this item";
						while (features.hasNext())
						{
							FeatureData item = features.next();
							ArrayDesignBlock block = Feature.getArrayDesignBlock(dc, item);
							int itemId = item.getId();
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
											type="checkbox" 
											name="<%=itemId%>" 
											value="<%=itemId%>" 
											title="TODO" 
											<%=request.getParameter(Integer.toString(itemId)) == null ? "" : "checked"%> 
										></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
											type="radio" 
											name="item_id" 
											value="<%=itemId%>" 
											title="TODO" 
											<%=selectedItemId == itemId ? "checked" : ""%>
										></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									></tbl:header>
								<tbl:cell column="position"><div class="link" onclick="itemOnClick(event, <%=itemId%>)" 
									title="<%=tooltip%>"><%=item.getPosition()%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="externalId"><div class="link" onclick="itemOnClick(event, <%=itemId%>)" 
									title="<%=tooltip%>"><%=HTML.encodeTags(item.getExternalId())%></div></tbl:cell>
								<tbl:cell column="block"><%=block.getBlockNumber()%></tbl:cell>
								<tbl:cell column="row"><%=item.getRow()%></tbl:cell>
								<tbl:cell column="column"><%=item.getColumn()%></tbl:cell>
								<tbl:cell column="metaGridX"><%=block.getMetaGridX()%></tbl:cell>
								<tbl:cell column="metaGridY"><%=block.getMetaGridY()%></tbl:cell>
								<tbl:cell column="blockSizeX"><%=block.getBlockSizeX()%></tbl:cell>
								<tbl:cell column="blockSizeY"><%=block.getBlockSizeY()%></tbl:cell>
								<tbl:cell column="originX"><%=block.getOriginX()%></tbl:cell>
								<tbl:cell column="originY"><%=block.getOriginY()%></tbl:cell>
								<tbl:cell column="spacingX"><%=block.getSpacingX()%></tbl:cell>
								<tbl:cell column="spacingY"><%=block.getSpacingY()%></tbl:cell>
								<tbl:cell column="diameter"><%=block.getFeatureDiameter()%></tbl:cell>
								<%
								ReporterData reporter = item.getReporter();
								if (reporter == null)
								{
									%>
									<tbl:cell column="reporter.name"><i>- none -</i></tbl:cell>
									<tbl:cell column="reporter.externalId"><i>- none -</i></tbl:cell>
									<tbl:cell column="reporter.symbol"><i>- none -</i></tbl:cell>
									<tbl:cell column="reporter.description"><i>- none -</i></tbl:cell>
									<tbl:cell column="entryDate"><i>- none -</i></tbl:cell>
									<tbl:cell column="reporter.lastUpdate"><i>- none -</i></tbl:cell>
									<tbl:cell column="reporter.reporterType"><i>- none -</i></tbl:cell>
									<%
									if (reporterProperties != null)
									{
										for (ExtendedProperty ep : reporterProperties)
										{
											String name = ep.getName();
											%>
											<tbl:cell column="<%="reporter."+name%>"><i>- none -</i></tbl:cell>
											<%
										}
									}
								}
								else
								{
									%>
									<tbl:cell column="reporter.name"><%=Base.getLink(ID, reporter.getName(), Item.REPORTER, reporter.getId(), true)%></tbl:cell>
									<tbl:cell column="reporter.externalId"><%=HTML.encodeTags(reporter.getExternalId())%></tbl:cell>
									<tbl:cell column="reporter.symbol"><%=HTML.encodeTags(reporter.getSymbol())%></tbl:cell>
									<tbl:cell column="reporter.description"><%=HTML.encodeTags(reporter.getDescription())%></tbl:cell>
									<tbl:cell column="reporter.entryDate" value="<%=reporter.getEntryDate()%>" />
									<tbl:cell column="reporter.lastUpdate" value="<%=reporter.getLastUpdate()%>" />
									<tbl:cell column="reporter.reporterType"
										><base:propertyvalue 
											dbcontrol="<%=dc%>" 
											item="<%=reporter%>" 
											property="reporterType"
											enableEditLink="<%=mode.hasEditLink()%>" 
											enablePropertyLink="<%=mode.hasPropertyLink()%>"
										/></tbl:cell>
									<%
									if (reporterProperties != null)
									{
										for (ExtendedProperty ep : reporterProperties)
										{
											String name = ep.getName();
											%>
											<tbl:cell column="<%="reporter."+name%>"><tbl:cellvalue value="<%=reporter.getExtended(name)%>" /></tbl:cell>
											<%
										}
									}
								}
								%>
								<%
								Well well = null;
								boolean readWell = true;
								try
								{
									well = Feature.getWell(dc, item);
								}
								catch (PermissionDeniedException ex)
								{
									readWell = false;
								}
								if (!readWell)
								{
									%>
									<tbl:cell column="well.row"><i>- denied -</i></tbl:cell>
									<tbl:cell column="well.column"><i>- denied -</i></tbl:cell>
									<tbl:cell column="well.plate"><i>- denied -</i></tbl:cell>
									<%
								}
								else if (well == null)
								{
									%>
									<tbl:cell column="well.row"><i>- none -</i></tbl:cell>
									<tbl:cell column="well.column"><i>- none -</i></tbl:cell>
									<tbl:cell column="well.plate"><i>- none -</i></tbl:cell>
									<%
								}
								else
								{
									%>
									<tbl:cell column="well.row"><tbl:cellvalue value="<%=well.getRow()%>"/></tbl:cell>
									<tbl:cell column="well.column"><tbl:cellvalue value="<%=well.getColumn()%>"/></tbl:cell>
									<tbl:cell column="well.plate"><%=Base.getLinkedName(ID, well.getPlate(), false, true)%></tbl:cell>
									<%
								}
								%>
							</tbl:row>
							<%
						}
					}
					%>
					</tbl:rows>
				</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=features == null || features.getTotalCount() == 0 ? "No features were found" : "No features on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=features == null ? 0 : features.getTotalCount()%>" 
					visible="<%=mode.hasNavigator()%>"
					locked="true"
				/>
				<%
			}
			%>
		</tbl:table>
		<base:buttongroup align="center">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		</t:tab>
		<t:tab id="overview" title="Overview" 
			tooltip="Display a tree overview of related items" />
		<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>" />
		</t:tabcontrol>
	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (features != null) features.close();
	if (dc != null) dc.close();
}
%>
